// <!-- ***************   【安卓打包注释】   *************** -->

(function(w) {
	function onPlusReady() {
		console.log("plusReady")
	}
	if (w.plus) {
		onPlusReady()
	} else {
		document.addEventListener("plusReady", onPlusReady, false)
	}
	var packName = null
	var xw_task = null
	var xw_uni = {
		//判断是否安装
		CheckAppIsInstall: function(pg) {
			console.log("CheckAppIsInstall" + pg)
			this.packName = pg
			var b = plus.runtime.isApplicationExist({
					pname: pg,
				}) ?
				1 :
				0

			console.log("CheckAppIsInstall  是否已安装 " + this.packName + b)
			return b
		},
		Browser: function(url) {
			plus.runtime.openURL(url)
			console.log(url)
		},
		//打开应用
		startAnotherApp: function(pg) {
			console.log("startAnotherApp" + pg)
			if (plus.os.name == "Android") {
				plus.runtime.launchApplication({
						pname: pg,
					},
					function(e) {
						alert("startAnotherApp failed: " + e.message)
					}
				)
			}
		},
		//下载任务
		downloadApkFile: function(Adid, AppUrl) {
			alert('开始后台下载，请稍后。。')
			console.log("downloadApkFile" + adid + " " + AppUrl)
			var index =
				AppUrl.lastIndexOf("/") > AppUrl.lastIndexOf("?") ?
				AppUrl.lastIndexOf("/") :
				AppUrl.lastIndexOf("?")
			var apk_name = "_downloads/" + AppUrl.substring(index + 1, AppUrl.length)
			if (apk_name.indexOf(".apk") == -1) {
				apk_name = apk_name + ".apk"
			}
			console.log("下载文件 " + apk_name)
			if (xw_task != null && xw_task.url === AppUrl) {
				console.log("任务正在下载中！")
				return
			}
			var options = {
				method: "GET",
				filename: apk_name,
			}
			console.log("开始创建下载任务 ")
			var precent = 0
			var pkName = this.packName
			xw_task = plus.downloader.createDownload(AppUrl, options, null)
			xw_task.addEventListener("statechanged", function(task, status) {
				if (!xw_task) {
					return
				}
				switch (task.state) {
					case 1: // 开始
						console.log("开始下载 ...")
						console.log("开始下载 ..." + pkName + "->" + precent)
						precent = 0
						break
					case 2: // 已连接到服务器
						console.log("链接到服务器... ")
						console.log("链接到服务器 ..." + pkName + "->" + precent)
						precent = 0
						break
					case 3: // 已接收到数据
						var cur_precent = parseInt(
							(100 * task.downloadedSize) / task.totalSize
						) //Math.round(task.downloadedSize * 100 / task.totalSize)
						if (precent != cur_precent) {
							precent = cur_precent
							console.log(
								"正在下载…… packageName->" +
								pkName +
								"  progress->" +
								precent +
								"%"
							)
							downloadApkFileProcessListener(Adid, precent)
						}
						break
					case 4: // 下载完成
						var filepath = task.filename
						console.log("下载完成 " + filepath)
						var install_options = {
							force: false,
						}
						plus.runtime.install(
							filepath,
							install_options,
							function(widgetInfo) {
								console.log("安装成功")
								xw_task = null
								console.log(xw_task == null)
							},
							function(e) {
								console.log("安装失败" + e.message)
								xw_task = null
								console.log(xw_task == null)
							}
						)
						break
				}
			})
			xw_task.start()
			console.log("下载任务创建成功 ")
		},
	}
	w.xw_uni = xw_uni
})(window)

// <!-- ***************   END   *************** -->
